org.restlet.util

## Class WrapperMap<K,V>

- java.lang.Object
- - org.restlet.util.WrapperMap<K,V>

All Implemented Interfaces:
  java.util.Map<K,V>

    public class WrapperMap<K,V>
    extends java.lang.Object
    implements java.util.Map<K,V>

Map wrapper. Modifiable map that delegates all methods to a wrapped map. This allows an easy subclassing.

Author:
  Jerome Louvel
See Also:
  The decorator (aka wrapper) pattern, `Collections`, `List`

### Nested Class Summary

### Nested classes/interfaces inherited from interface java.util.Map

`java.util.Map.Entry<K,V>`

### Constructor Summary

Constructors
Constructor and Description
`WrapperMap()` Constructor.
`WrapperMap(java.util.Map<K,V> delegate)` Constructor.

### Method Summary

Methods
`void` `clear()` Removes all mappings from this Map.
`boolean` `containsKey(java.lang.Object key)` Returns true if this map contains a mapping for the specified key.
`boolean` `containsValue(java.lang.Object value)` Returns true if this map maps one or more keys to the specified value.
`java.util.Set<java.util.Map.Entry<K,V>>` `entrySet()` Returns a set view of the mappings contained in this map.
`boolean` `equals(java.lang.Object o)` Compares the specified object with this map for equality.
`V` `get(java.lang.Object key)` Returns the value to which this map maps the specified key.
`protected java.util.Map<K,V>` `getDelegate()` Returns the delegate list.
`int` `hashCode()` Returns the hash code value for this map.
`boolean` `isEmpty()` Returns true if this map contains no key-value mappings.
`java.util.Set<K>` `keySet()` Returns a set view of the keys contained in this map.
`V` `put(K key, V value)` Associates the specified value with the specified key in this map (optional operation).
`void` `putAll(java.util.Map<? extends K,? extends V> t)` Copies all of the mappings from the specified map to this map (optional operation).
`V` `remove(java.lang.Object key)` Removes the mapping for this key from this map if it is present (optional operation).
`int` `size()` Returns the number of key-value mappings in this map.
`java.util.Collection<V>` `values()` Returns a collection view of the values contained in this map.

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### WrapperMap

    public WrapperMap()

Constructor.

#### WrapperMap

    public WrapperMap(java.util.Map<K,V> delegate)

Constructor.

Parameters:
  `delegate` - The delegate list.

### Method Detail

#### clear

    public void clear()

Removes all mappings from this Map.

Specified by:
  `clear` in interface `java.util.Map<K,V>`

#### containsKey

    public boolean containsKey(java.lang.Object key)

Returns true if this map contains a mapping for the specified key.

Specified by:
  `containsKey` in interface `java.util.Map<K,V>`
Parameters:
  `key` - The key to look up.
Returns:
  True if this map contains a mapping for the specified key.

#### containsValue

    public boolean containsValue(java.lang.Object value)

Returns true if this map maps one or more keys to the specified value.

Specified by:
  `containsValue` in interface `java.util.Map<K,V>`
Parameters:
  `value` - The value to look up
Returns:
  True if this map maps one or more keys to the specified value.

#### entrySet

    public java.util.Set<java.util.Map.Entry<K,V>> entrySet()

Returns a set view of the mappings contained in this map.

Specified by:
  `entrySet` in interface `java.util.Map<K,V>`
Returns:
  A set view of the mappings contained in this map.

#### equals

    public boolean equals(java.lang.Object o)

Compares the specified object with this map for equality.

Specified by:
  `equals` in interface `java.util.Map<K,V>`
Overrides:
  `equals` in class `java.lang.Object`
Parameters:
  `o` - Object to be compared for equality with this map.
Returns:
  True if the specified object is equal to this map.

#### get

    public V get(java.lang.Object key)

Returns the value to which this map maps the specified key.

Specified by:
  `get` in interface `java.util.Map<K,V>`
Parameters:
  `key` - Key whose associated value is to be returned.
Returns:
  The value to which this map maps the specified key, or null if the map contains no mapping for this key.

#### getDelegate

    protected java.util.Map<K,V> getDelegate()

Returns the delegate list.

Returns:
  The delegate list.

#### hashCode

    public int hashCode()

Returns the hash code value for this map.

Specified by:
  `hashCode` in interface `java.util.Map<K,V>`
Overrides:
  `hashCode` in class `java.lang.Object`
Returns:
  The hash code value for this map.

#### isEmpty

    public boolean isEmpty()

Returns true if this map contains no key-value mappings.

Specified by:
  `isEmpty` in interface `java.util.Map<K,V>`
Returns:
  True if this map contains no key-value mappings.

#### keySet

    public java.util.Set<K> keySet()

Returns a set view of the keys contained in this map.

Specified by:
  `keySet` in interface `java.util.Map<K,V>`
Returns:
  A set view of the keys contained in this map.

#### put

    public V put(K key,
        V value)

Associates the specified value with the specified key in this map (optional operation).

Specified by:
  `put` in interface `java.util.Map<K,V>`
Parameters:
  `key` - Key with which the specified value is to be associated.
  `value` - Value to be associated with the specified key.
Returns:
  The previous value associated with specified key, or null if there was no mapping for key. A null return can also indicate that the map previously associated null with the specified key, if the implementation supports null values.

#### putAll

    public void putAll(java.util.Map<? extends K,? extends V> t)

Copies all of the mappings from the specified map to this map (optional operation).

Specified by:
  `putAll` in interface `java.util.Map<K,V>`
Parameters:
  `t` - Mappings to be stored in this map.

#### remove

    public V remove(java.lang.Object key)

Removes the mapping for this key from this map if it is present (optional operation).

Specified by:
  `remove` in interface `java.util.Map<K,V>`
Parameters:
  `key` - Key whose mapping is to be removed from the map.
Returns:
  The previous value associated with specified key, or null if there was no mapping for key.

#### size

    public int size()

Returns the number of key-value mappings in this map.

Specified by:
  `size` in interface `java.util.Map<K,V>`
Returns:
  The number of key-value mappings in this map.

#### values

    public java.util.Collection<V> values()

Returns a collection view of the values contained in this map.

Specified by:
  `values` in interface `java.util.Map<K,V>`
Returns:
  A collection view of the values contained in this map.